"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
// @ts-ignore
const typescript = require("rollup-plugin-typescript");
function createRollupConfig(isServer) {
    // 打包后会加一层 lib/
    const resolvePath = (p) => path.resolve(__dirname, '../..', p);
    const inputOptions = {
        input: isServer ? resolvePath('src/server.ts') : resolvePath('src/client.tsx'),
        plugins: [
            typescript({
                tsconfig: resolvePath('tsconfig.json'),
            })
        ]
    };
    const outputOptions = {
        file: isServer ? resolvePath('lib/server.js') : resolvePath('lib/client.js'),
        format: isServer ? 'cjs' : 'umd',
        name: 'ServerRenderer',
    };
    return {
        inputOptions,
        outputOptions,
    };
}
exports.createRollupConfig = createRollupConfig;
